<?php defined('SYSPATH') || die('No direct script access.');

class Model_System extends Model
{
    protected static $configs = [];

    public static $SemesterID;

    // load json-config from app/config/ dir
    public static function loadConfig($name = 'general.json') {
        if (array_key_exists($name, self::$configs)) {
            return self::$configs[$name];
        } else {
            $data = file_get_contents(APPPATH . 'config' . DIRECTORY_SEPARATOR . $name);
            $data = self::json_clean_decode($data);
            self::$configs[$name] = $data;
            return $data;
        }
    }

    public static function saveConfig($name) {
        // Not implemented yet
    }


    public static function getChangeLog($fileName) {
        $file = APPPATH . $fileName;
        $source = file_exists($file) ? file_get_contents($file) : '';
        $blocks = preg_split("/[\r\n]*---[-]*[\r\n]*/", $source);

        $log = [];
        foreach ($blocks as $row) {
            $log[] = [
                'date' => substr($row, 0, strpos($row, PHP_EOL)),
                'text' => trim(substr($row, strpos($row, PHP_EOL))),
            ];
        }

        return $log;
    }


    /**
     * Clean comments of json content and decode it with json_decode().
     * Work like the original php json_decode() function with the same params
     *
     * @param   string  $json    The json string being decoded
     * @param   bool    $assoc   When TRUE, returned objects will be converted into associative arrays.
     * @param   integer $depth   User specified recursion depth. (>=5.3)
     * @param   integer $options Bitmask of JSON decode options. (>=5.4)
     * @return  mixed
     */
    private static function json_clean_decode($json, $assoc = false, $depth = 512, $options = 0) {
        // search and remove comments like /* */ and //
        $json = preg_replace("#(/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*+/)|([\s\t]//.*)|(^//.*)#", '', $json);

        return json_decode($json, $assoc, $depth, $options);
    }
}

Model_System::$SemesterID = Model_System::loadConfig('general.json')->SemesterID;
